#!/usr/bin/env python

import sys, os
from stat import *
from distutils.core import setup
from distutils.command.install import install as _install

INSTALLED_FILES = '.installed_files'

#stolen from ccsm
class install (_install):

	def run (self):

		_install.run(self)
		outputs = self.get_outputs()
		data = '\n'.join(outputs)
		try:
			f = open(INSTALLED_FILES, 'w')
		except:
			self.warn ('Could not write installed files list %s' %INSTALLED_FILES)
			return

		f.write(data)
		f.close()

class uninstall(_install):

	def run(self):
		try:
			files = file(INSTALLED_FILES, 'r').readlines()
		except:
			self.warn('Could not read installed files list %s' %INSTALLED_FILES)
			return

		for f in files:
			print 'Uninstalling %s' %f.strip()
			try:
				os.unlink(f.strip())
			except:
				self.warn('Could not remove file %s' %f)
		os.remove(INSTALLED_FILES)

data_files = [
	('share/applications',['data/share/applications/boot-repair.desktop']),
	('share/boot-sav',['data/share/boot-sav/boot-repair.png','data/share/boot-sav/boot-repair-actions.sh','data/share/boot-sav/boot-repair-translations.sh','data/share/boot-sav/boot-repair-gui.sh','data/share/boot-sav/bis.sh','data/share/boot-sav/boot-repair.sh','data/share/boot-sav/bis-git.sh']),
	('share/icons/hicolor/128x128/apps',['data/share/icons/hicolor/128x128/apps/boot-repair.png']),
	('share/man/man8',['data/share/man/man8/boot-repair.8.gz']),
]

setup(
	name='boot-repair',
	version='3.16',
	description="Simple tool to repair frequent boot problems",
	author='Yann Mrn',
	author_email='yannubuntu@gmail.com',
	url='https://launchpad.net/boot-repair',
	data_files=data_files,
	scripts=['boot-repair'],
	cmdclass={
		'uninstall': uninstall,
		'install': install},
)

#Stolen from ccsm's setup.py
if sys.argv[1] == 'install':

	prefix = None

	if len (sys.argv) > 2:
		i = 0
		for o in sys.argv:
			if o.startswith ("--prefix"):
				if o == "--prefix":
					if len (sys.argv) >= i:
						prefix = sys.argv[i + 1]
					sys.argv.remove (prefix)
				elif o.startswith ("--prefix=") and len (o[9:]):
					prefix = o[9:]
				sys.argv.remove (o)
				break
			i += 1
